## freedict-tools 0.3

=== Makefile ===
# Makefile that can call `make' for all dictionary modules

include Makefile.config

BUILD = set -e && for file in $(FREEDICTDIR)/???-???; do $(MAKE) -C $$file $@; done

# Calls default target for each dictionary module.
# Note: This is a conflict if you wanted to call
# the 'all' target of each dictionary module.
all:
	for file in $(FREEDICTDIR)/???-???; do $(MAKE) -C $$file; done

# most useful targets
release-%:
	$(BUILD)

dist:
	$(BUILD)

# if you forgot where you made changes... :)
commit:
	$(BUILD)

vok:
	$(BUILD)

install:
	$(BUILD)

uninstall:
	$(BUILD)

dbupdate:
	$(BUILD)

clean:
	$(BUILD)

tests:
	$(BUILD)

test:
	$(BUILD)

validation:
	$(BUILD)

update:
	for file in $(FREEDICTDIR)/???-???; do cd $$file && cvs -z3 update; done

.PHONY: install uninstall dbupdate commit release-% all vok clean tests update dist

## freedict-tools 0.5.0~beta.4

=== Makefile ===
# This makefile contains all recipes to build and manage the FreeDict
# tools, including the API. It also provides targets to build a release archive
# with the latest tools included.

FREEDICT_TOOLS ?= .
include $(FREEDICT_TOOLS)/mk/config.mk

VERSION = 0.4
PREFIX ?= usr
DESTDIR ?= 
INSTALLDIR ?= $(abspath $(DESTDIR)/$(PREFIX)/share/freedict)

dirs = api JMdict lib mk xquery xsl/inc
TARGET_DIRS = $(addprefix $(INSTALLDIR)/tools/, $(dirs))


api: #! generate the api with information about all dictionaries and their downloads at the configured api path
api:
	$(call mount_or_reuse); \
		$(call exc_pyscript,fd_api) || sleep 1; \
		$(call umount_or_keep)
	@$(MAKE) -C $(FREEDICT_TOOLS) --no-print-directory api-validation

# allow retrieval of API path from Makefile and from rule below
get_api_path=$(call exc_pyscript,fd_file_mgr,-a) | tr -d '\n'
api-path: #! print the output directory to the generated API file (read from configuration) (trailing newline is removed)
	@$(call get_api_path)

api-validation: #! validate the freedict-database.xml against its RNG schema
	@echo Hi $(call get_api_path)
	xmllint --noout --relaxng freedict-database.rng $(shell $(call get_api_path))/freedict-database.xml




mount: #! mount or synchronize FreeDict releases / generated dictionaries
	$(call exc_pyscript,fd_file_mgr,-m)

need-update: #! queries for unreleased dictionaries or for those with newer source changes
	@$(call mount_or_reuse); \
		$(call exc_pyscript,fd_api,-n)\
			|| sleep 1; \
		$(call umount_or_keep)

umount: #! runs umount / clean up actions for unmounting remote volumes (if SSH is used)
	@$(call exc_pyscript,fd_file_mgr,-u)

$(BUILD_DIR)/freedict-tools-$(VERSION).tar.bz2: Makefile* *.pl
ifeq ($(wildcard $(BUILD_DIR)),)
	mkdir -p $(BUILD_DIR)
endif
	tar --totals --exclude="*/.svn/*" --exclude="*/.*" \
	  --exclude="*/charlint*" --exclude="*/UnicodeData.txt" \
	  --exclude="*/ergane/jet4/*" \
	  --exclude="*/ergane/unzip/*" \
	  --exclude="*/ergane/zip/*" \
	  --exclude="*/__pycache__/*" \
	  -cvjf $@ ../tools

install-deps: #! probe current operating system to install build prerequisites for dictionary development
	echo -n "Do you want to use unison or sshfs? Enter one of them or nothing: "; \
	read ACCESS_METHOD; \
	if command -v apt-get; then \
		sudo apt-get install unzip tar xsltproc libxml-libxml-perl python3 $$ACCESS_METHOD; \
	elif command -v pacman;  then \
		if [ `uname -o` = 'GNU/Linux' ]; then \
			sudo pacman -S unzip tar libxslt libxml-perl python $$ACCESS_METHOD; \
		else \
			echo "Sorry, but it seems you're not running pacman on GNU/Linux. There's currently no installation rule for this platform."; \
		fi; \
	else \
		echo "Unknown platform. Feel free to report the corresponding packages to us."; \
	fi


# This helps to express \n as a special variable to Make; it **needs** two
# newlines within the define
define newline


endef

#  This may not contain apostrophes
define VENV_HELP
A virtual environment is a local copy of all Python utilities, scripts and
libraries for Python development. With a virtual environment, you do not need to
install all the FreeDict scripts globally in your system, but you are of course
free to do so. The mk_venv command will make sure that the virtual environment
is created at the correct place; use "P=/some/path" to specify the path.
Example:
    make mk_venv P=../fd-venv
After installation, you will be asked whether the virtual environment should be
added to the FreeDict configuration. This is generally a good idea, because this
means that the FreeDict build system will take care of all the required steps.
endef

mk_venv-help:
	echo -e '$(subst $(newline),\n,${VENV_HELP})'

mk_venv: #! initialise a new (Python) virtual environment; use mk_venv-help for detailled help
	@if [ "${P}" = '' ]; then \
		echo Need to give a path with P=, e.g. "make mk_venv P=/some/dir"; \
		exit 222; fi
	@if ! command -v virtualenv &> /dev/null; then \
		echo '`virtualenv` not found, please install it and try again.'; exit 10; \
		fi
	@virtualenv -q -p $(PYTHON) ${P}
	source ${P}/bin/activate; pip install -r requirements.txt
	@if [ "$(FREEDICTRC)" = "" ]; then \
		echo "You don't have a FreeDict configuration yet. Please create one, "; \
		echo 'as described in the chapter "Build System" of the FreeDict HOWTO';\
		echo "from the Wiki";fi
	if ! [ -f $(FREEDICTRC) ]; then \
		NO_CONF=1; \
	elif ! grep virtual_env < $(FREEDICTRC) &> /dev/null; then \
		NO_CONF=1; \
	else NO_CONF=0; \
	fi; \
	if [ $$NO_CONF -eq 1 ]; then \
		echo -n "Do you want to add the virtual_env to the FreeDict configuration? [y|n] "; \
		read CHOICE;\
		if [ "$$CHOICE" = "y" ]; then \
			mkdir -p $(dir $(FREEDICTRC));\
			touch $(FREEDICTRC);\
			PATH=$(abspath ${P}); \
			if ! grep -r '[DEFAULT]' $(FREEDICTRC) &> /dev/null; then \
				echo >> $(FREEDICTRC);\
				echo '[DEFAULT]' >> $(FREEDICTRC); \
				echo "virtual_env = $$PATH" >> $(FREEDICTRC) ;\
			else \
				sed -i 's|\[DEFAULT\]|[DEFAULT]\nvirtual_env = '$$PATH'|' $(FREEDICTRC); \
			fi; \
			echo done; \
		fi; \
	fi

# NOTE: the directories below HAVE to be on one line
DIRS := api api/generator api/file_manager api/generator/apigen mk xquery xsl/inc
PATHS := $(wildcard api/*.py api/*.md api/generator/*.py api/generator/apigen/*.py \ api/file_manager/*.py \
	freedict-database.rng \
	mk/* xsl/inc/* \
	xquery/* xsl/tei2c5.xsl)
install: #! install the tools to $$DESTDIR/$PREFIX/share/freedict (default /usr/local/share/freedict)
install:
	@echo Creating directories in $(INSTALLDIR)…
	@set -e; for d in $(DIRS); do \
		install -d $(INSTALLDIR)/$$d; \
	done
	@echo Copying files to $(INSTALLDIR)…
	@set -e; for f in $(PATHS); do \
		if [ -f $$f ]; then \
			install -m 644 $$f $(INSTALLDIR)/$$f; \
		fi \
	done




release: #! build a release tarball in $$BUILD_DIR, ../build by default
release: $(BUILD_DIR)/freedict-tools-$(VERSION).tar.bz2

release-path: #! print the output directory to which releases are deployed (read from configuration); trailing newline is removed
	@$(call exc_pyscript,fd_file_mgr,-r) | tr -d '\n'

.PHONY: release install api all mount umount api-validation

=== requirements.txt ===
-e git://github.com/freedict/tools.git#egg=fd_fd_tool&subdirectory=fd_tool
-e git://github.com/freedict/tools.git#egg=fd_import&subdirectory=importers
semver==2.8.1
PyICU==2.0.3
ankisync==0.1.6.3
-e git://github.com/itkach/slob.git#egg=slob
-e git://github.com/itkach/tei2slob.git#egg=tei2slob

=== debian/changelog ===
freedict-tools (0.5.0~beta.4-1) unstable; urgency=medium

  * new upstream version

 -- Sebastian Humenda <shumenda@gmx.de>  Wed, 30 Jan 2019 11:56:19 +0100

freedict-tools (0.5.0~beta.3-1) unstable; urgency=medium

  * new upstream version: more teiaddphoneitcs fixes, build system fixes

 -- Sebastian Humenda <shumenda@gmx.de>  Tue, 29 Jan 2019 15:51:32 +0100

freedict-tools (0.5.0~beta.2-4) unstable; urgency=medium

  * phonetics: generated phonetics could potentially display unrelated IPA for
    headwords, fixed by applying the upstream patch

 -- Sebastian Humenda <shumenda@gmx.de>  Sat, 26 Jan 2019 18:29:37 +0100

freedict-tools (0.5.0~beta.2-3) unstable; urgency=medium

  * debian packaging maintenance changes:
    * correctly include or deny dictionaries on given filter criteria
    * omit version number in package descriptions, if wanted
  * overwrite FREEDICT_TOOLS environment variable to not make the build depend
    on environment variables being set

 -- Sebastian Humenda <shumenda@gmx.de>  Fri, 02 Nov 2018 19:11:04 +0100

freedict-tools (0.5.0~beta.2-2) unstable; urgency=medium

  * backport upstream patch to avoid encoding issues with teiaddphonetics for
    the C locale
  * add helper script for debian FreeDict packaging

 -- Sebastian Humenda <shumenda@gmx.de>  Tue, 23 Oct 2018 15:44:18 +0200

freedict-tools (0.5.0~beta.2-1) unstable; urgency=medium

  * initial release (Closes: #905270)

 -- Sebastian Humenda <shumenda@gmx.de>  Sun, 23 Sep 2018 18:31:39 +0200

=== debian/control ===
Source: freedict-tools
Section: devel
Priority: optional
Maintainer: Sebastian Humenda <shumenda@gmx.de>
Uploaders: Joost van Baal <joostvb@debian.org>
Build-Depends: debhelper (>= 11)
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/freedict-team/freedict-tools
Vcs-Git: https://salsa.debian.org/freedict-team/freedict-tools.git
Homepage: http://www.freedict.org/
Rules-Requires-Root: no

Package: freedict-tools
Architecture: all
Depends: ${misc:Depends}, xsltproc, dictfmt, dictzip, libxml-libxml-perl,
    iso-codes, libxml-libxslt-perl, espeak-ng, unzip, licensecheck
Recommends: python3
Description: Development files for the FreeDict dictionary packages
 This package contains the FreeDict build system and its scripts, used to build
 and distribute dictionaries in the TEI format. FreeDict dictionaries are
 stored in a format independent from the dictionary program, called TEI. These
 utilities and scripts convert the TEI-formatted dictionaries into formats
 understood by dictionary programs.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export PREFIX=/usr

export FREEDICT_TOOLS = .

%:
	dh $@

=== debian/watch ===
# watch control file for uscan, see uscan(1)

# test this file by running
#   $ uscan --report --verbose

version=4


opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/gladtex-$1\.tar\.gz/ \
  https://github.com/freedict/tools/releases .*/v?(\d\S*)\.tar\.gz

## freedict-tools 0.5.0

=== Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 INSTALLDIR ?= $(abspath $(DESTDIR)/$(PREFIX)/share/freedict)
 
 dirs = api JMdict lib mk xquery xsl/inc
-TARGET_DIRS = $(addprefix $(INSTALLDIR)/tools/, $(dirs))
+TARGET_INSTALL_DIRS = $(addprefix $(INSTALLDIR)/tools/, $(dirs))
 
 
 api: #! generate the api with information about all dictionaries and their downloads at the configured api path
@@ -27,7 +27,6 @@
 	@$(call get_api_path)
 
 api-validation: #! validate the freedict-database.xml against its RNG schema
-	@echo Hi $(call get_api_path)
 	xmllint --noout --relaxng freedict-database.rng $(shell $(call get_api_path))/freedict-database.xml
 
 
@@ -89,6 +88,10 @@
 is created at the correct place; use "P=/some/path" to specify the path.
 Example:
     make mk_venv P=../fd-venv
+NOTE: If you have not pkg-config on your system, you need to manually set the
+	environment variable ICU_VERSION to the version of libicu on your system.
+	This is due to some internal restructuring of the libicu library that we
+	depend on.
 After installation, you will be asked whether the virtual environment should be
 added to the FreeDict configuration. This is generally a good idea, because this
 means that the FreeDict build system will take care of all the required steps.
@@ -105,6 +108,14 @@
 		echo '`virtualenv` not found, please install it and try again.'; exit 10; \
 		fi
 	@virtualenv -q -p $(PYTHON) ${P}
+	@if [ -z "$(ICU_VERSION)" ]; then \
+		if ! command -v pkg-config; then \
+			echo "Environment variable ICU_VERSION unset and 'pkg-config' not found.";  \
+			echo "Please set ICU_VERSION to the version of libicu installed on your system."; \
+			exit 127; \
+		fi; \
+		export ICU_VERSION=`pkg-config --modversion icu-i18n`; \
+	fi; \
 	source ${P}/bin/activate; pip install -r requirements.txt
 	@if [ "$(FREEDICTRC)" = "" ]; then \
 		echo "You don't have a FreeDict configuration yet. Please create one, "; \
@@ -135,19 +146,19 @@
 	fi
 
 # NOTE: the directories below HAVE to be on one line
-DIRS := api api/generator api/file_manager api/generator/apigen mk xquery xsl/inc
-PATHS := $(wildcard api/*.py api/*.md api/generator/*.py api/generator/apigen/*.py \ api/file_manager/*.py \
+INSTALL_DIRS := api api/generator api/file_manager api/generator/apigen mk xquery xsl/inc
+INSTALL_PATHS := $(wildcard api/*.py api/generator/*.py api/generator/apigen/*.py api/file_manager/*.py \
 	freedict-database.rng \
-	mk/* xsl/inc/* \
+	mk/*.mk xsl/inc/* \
 	xquery/* xsl/tei2c5.xsl)
 install: #! install the tools to $$DESTDIR/$PREFIX/share/freedict (default /usr/local/share/freedict)
 install:
 	@echo Creating directories in $(INSTALLDIR)…
-	@set -e; for d in $(DIRS); do \
+	@set -e; for d in $(INSTALL_DIRS); do \
 		install -d $(INSTALLDIR)/$$d; \
 	done
 	@echo Copying files to $(INSTALLDIR)…
-	@set -e; for f in $(PATHS); do \
+	@set -e; for f in $(INSTALL_PATHS); do \
 		if [ -f $$f ]; then \
 			install -m 644 $$f $(INSTALLDIR)/$$f; \
 		fi \

=== requirements.txt ===
-e git://github.com/freedict/tools.git#egg=fd_fd_tool&subdirectory=fd_tool
-e git://github.com/freedict/tools.git#egg=fd_import&subdirectory=importers
semver==2.8.1
#ToDo: 2.2 has a bug where setting ICU_VERSION is not enough, it's fixed on
#latest master; if you read this when 2.3 is out already, please remove this and
#the notice
#PyICU>=2.2
-e git://github.com/ovalhub/pyicu@3614198d130273ec4acc029bd7ded083e6309224#egg=pyicu
ankisync==0.1.6.3
-e git://github.com/itkach/slob.git#egg=slob
-e git://github.com/itkach/tei2slob.git#egg=tei2slob

=== debian/changelog ===
freedict-tools (0.5.0-2) unstable; urgency=medium

  * Add python3 as build dependency (Closes #978974)

 -- Sebastian Humenda <shumenda@gmx.de>  Fri, 01 Jan 2021 18:07:19 +0100

freedict-tools (0.5.0-1) unstable; urgency=medium

  * new upstream version

 -- Sebastian Humenda <shumenda@gmx.de>  Wed, 30 Dec 2020 19:25:56 +0100

=== debian/control ===
Source: freedict-tools
Section: devel
Priority: optional
Maintainer: Sebastian Humenda <shumenda@gmx.de>
Build-Depends: debhelper-compat (= 13), python3
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/freedict-team/freedict-tools
Vcs-Git: https://salsa.debian.org/freedict-team/freedict-tools.git
Homepage: https://www.freedict.org/
Rules-Requires-Root: no

Package: freedict-tools
Architecture: all
Depends: ${misc:Depends}, python3, xsltproc, dictfmt, dictzip, iso-codes, espeak-ng,
    licensecheck
Description: Development files for the FreeDict dictionary packages
 This package contains the FreeDict build system and its scripts, used to build
 and distribute dictionaries in the TEI format. FreeDict dictionaries are
 stored in a format independent from the dictionary program, called TEI. These
 utilities and scripts convert the TEI-formatted dictionaries into formats
 understood by dictionary programs.

=== debian/watch ===
--- 
+++ 
@@ -6,5 +6,5 @@
 version=4
 
 
-opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/gladtex-$1\.tar\.gz/ \
+opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/freedict-tools-$1\.tar\.gz/ \
   https://github.com/freedict/tools/releases .*/v?(\d\S*)\.tar\.gz

## freedict-tools 0.6.0

=== requirements.txt ===
-e git://github.com/freedict/tools.git#egg=fd_tool&subdirectory=fd_tool
-e git://github.com/freedict/tools.git#egg=fd_import&subdirectory=importers
semver==2.8.1
PyICU>=2.3
-e git://github.com/ovalhub/pyicu@3614198d130273ec4acc029bd7ded083e6309224#egg=pyicu
ankisync==0.1.6.3
-e git://github.com/itkach/slob.git#egg=slob
-e git://github.com/itkach/tei2slob.git#egg=tei2slob

=== importers/ding2tei/dict/tei/eng-deu/Makefile ===
FREEDICT_TOOLS ?= ../../../../..

DISTFILES = eng-deu.tei

include $(FREEDICT_TOOLS)/mk/dicts.mk

=== debian/changelog ===
freedict-tools (0.6.0-2) unstable; urgency=medium

  * Fix fetchdictdata.py to correctly determine the licence of dictionaries.

 -- Sebastian Humenda <shumenda@gmx.de>  Fri, 22 Apr 2022 21:36:50 +0200

freedict-tools (0.6.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.5.1, no changes needed.

  [ Sebastian Humenda ]
  * New upstream release
  * Update standards version to 4.6.0.1

 -- Sebastian Humenda <shumenda@gmx.de>  Thu, 21 Apr 2022 23:06:30 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Sebastian Humenda <shumenda@gmx.de>
 Build-Depends: debhelper-compat (= 13), python3
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0.1
 Vcs-Browser: https://salsa.debian.org/freedict-team/freedict-tools
 Vcs-Git: https://salsa.debian.org/freedict-team/freedict-tools.git
 Homepage: https://www.freedict.org/

## freedict-tools 0.7.0

=== requirements.txt ===
-e git+https://github.com/freedict/tools#egg=fd_tool&subdirectory=fd_tool
-e git+https://github.com/freedict/tools#egg=fd_import&subdirectory=importers
semver==2.8.1
pyicu>= 2.10
ankisync==0.1.6.3
-e git+https://github.com/itkach/slob#egg=slob
-e git+https://github.com/itkach/tei2slob#egg=tei2slob
pyglossary>=4.5.0

=== importers/ding2tei/dict/tei/deu-eng/Makefile ===
FREEDICT_TOOLS ?= ../../../../..

DISTFILES = deu-eng.tei

include $(FREEDICT_TOOLS)/mk/dicts.mk

=== debian/changelog ===
freedict-tools (0.7.0-2) unstable; urgency=medium

  * fix Debian script to detect licence information for d/copyright
  * remove outdated dependency on kdict for generated control snippets
  * enable stardict support

 -- Sebastian Humenda <shumenda@gmx.de>  Mon, 07 Apr 2025 16:25:47 +0200

freedict-tools (0.7.0-1) unstable; urgency=medium

  * new upstream release

 -- Sebastian Humenda <shumenda@gmx.de>  Thu, 31 Oct 2024 22:38:40 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Sebastian Humenda <shumenda@gmx.de>
 Build-Depends: debhelper-compat (= 13), python3
-Standards-Version: 4.6.0.1
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/freedict-team/freedict-tools
 Vcs-Git: https://salsa.debian.org/freedict-team/freedict-tools.git
 Homepage: https://www.freedict.org/
@@ -12,7 +12,7 @@
 Package: freedict-tools
 Architecture: all
 Depends: ${misc:Depends}, python3, xsltproc, dictfmt, dictzip, iso-codes, espeak-ng,
-    licensecheck
+    licensecheck, python3-pyglossary (>= 5.0~)
 Description: Development files for the FreeDict dictionary packages
  This package contains the FreeDict build system and its scripts, used to build
  and distribute dictionaries in the TEI format. FreeDict dictionaries are

=== debian/rules ===
--- 
+++ 
@@ -8,3 +8,7 @@
 
 %:
 	dh $@
+
+execute_after_dh_install:
+	dh_fixperms
+	chmod a+x debian/freedict-tools/usr/share/freedict/teiaddphonetics

=== debian/watch ===
--- 
+++ 
@@ -7,4 +7,4 @@
 
 
 opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/freedict-tools-$1\.tar\.gz/ \
-  https://github.com/freedict/tools/releases .*/v?(\d\S*)\.tar\.gz
+  https://github.com/freedict/tools/tags .*/v?(\d\S+)\.tar\.gz
